#!/usr/bin/env python3
import subprocess
import json
import sys
import arrow

'''
    cmd = "/Users/emile/bin/ido +dc RIS_RIB_V +xt %s -M 0/0 +S +M +T +minpwr 50 > %s" % ( ts, fname) # 50 to reduce multi origin
    ###DEBUG cmd = "/Users/emile/bin/ido +dc RIS_RIB_V +xt %s -M 193/8 +S +M +T +minpwr 50 > ./data/tbl.%s" % ( ts, ts ) # 50 to reduce multi origin
    print( now,ts,cmd , file=sys.stderr )
    ###### process = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
    if not os.path.isfile(fname):
        os.system( cmd )
    with open("./data/tbl.%s" % ts) as inf:
    #while True:
    #        output = process.stdout.readline()
    #        if output == '' and process.poll() is not None:
    #            break
    #        if output:
    #            output = str( output )
    #
        for output in inf:
'''

def res2cc( ts, res, cache ):
    if res in cache:
        return cache[res]
    else:
        cc = ''
        cmd = "/Users/emile/bin/ido +dc RIR_STATS +xt %s %s +S +M +T " % ( ts, res) 
        process = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
        while True:
            output = process.stdout.readline().decode()
            output = output.rstrip('\n')
            if output == '' and process.poll() is not None:
                break
            if output:
                try:
                    f = output.split('|')
                    cc = f[1]
                except:    
                    print("ERROR",output,ts,res, file=sys.stderr)
        cache[res] = cc
        return cc

outj = open("countries.netdiff.v4.jsonf",'w+', buffering=1)

old_ts = None
data = {}
with open("netdiff.v4.jsonf") as jin:
    for line in jin:
        res2cc_cache = {} # a cache per line
        d = json.loads( line )
        ts = arrow.get( d['ts'], tz='UTC' ).floor('day').timestamp # this way we aggregate (and RIR stats caches work!)  ### MAKE THIS AGGREGATE WORK
        print( d['ts'], ts, file=sys.stderr )

        data['ts'] = ts
        data.setdefault('per_cc', {})

        #for res_label in ('dropped_pfxes','added_pfxes','changed_pfxes','asns_dropped_pfxes','asns_added_pfxes','asns_changed_pfxes'):
        d['asns_any'] = set(d['asns_dropped_pfxes']) | set(d['asns_added_pfxes']) | set(d['asns_changed_pfxes'])
        for res_label in ('asns_dropped_pfxes','asns_added_pfxes','asns_changed_pfxes','asns_any'):
            ## print("label", pfx_label)
            resources = d[ res_label ]
            for res in resources:
                ### use asns and pfxes interchangable right now. this needs to change quite likely ...
                cc = res2cc( ts, res, res2cc_cache )
                #data['per_cc'].setdefault( cc, {'dropped_pfxes': 0, 'added_pfxes': 0, 'changed_pfxes': 0, 'asns_dropped_pfxes': 0,'asns_added_pfxes': 0, 'asns_changed_pfxes': 0} )
                data['per_cc'].setdefault( cc, {'asns_dropped_pfxes': 0,'asns_added_pfxes': 0, 'asns_changed_pfxes': 0, 'asns_any': 0} )
                data['per_cc'][ cc ][ res_label ] += 1
                ##print(ts,res_label,res,cc, file=sys.stderr)
        if old_ts != None and ts != old_ts:
            #json.dump( data, outj )
            print( "dumping!", file=sys.stderr )
            print( json.dumps( data ), file=outj )
            data = {}
        else:
            print( "skipping!", file=sys.stderr )
        old_ts = ts
#json.dump( data, outj )
print( json.dumps( data ), file=outj )
#print( json.dumps( data ) )

## needs normalisation for the whole data structure. fill gaps for zeros. etc
'''
print(json.dumps({
        'min_ts': min_ts,
        'max_ts': max_ts,
        'data': per_cc_stats,
}))
'''
